from subprocess import check_call
import pandas as pd
import numpy as np
import os

prefix = 'E_0_GP_0_'

allFiles = ['strainPath80017.csv']
Geo = ['80017_3_128.geo']
msh = ['80017_3_128.msh']
VRS = [[-1, 0.398951285269109, 10.0]]
thread = 1

def compute_ES(F, P):
    Fmat = np.zeros([3, 3])
    Fmat[0, 0] = F[0] + 1
    Fmat[1, 0] = F[1]
    Fmat[2, 0] = F[2]
    Fmat[0, 1] = F[3]
    Fmat[1, 1] = F[4] + 1
    Fmat[2, 1] = F[5]
    Fmat[0, 2] = F[6]
    Fmat[1, 2] = F[7]
    Fmat[2, 2] = F[8] + 1
    Pmat = np.zeros([3, 3])
    Pmat[0, 0] = P[0]
    Pmat[1, 0] = P[1]
    Pmat[2, 0] = P[2]
    Pmat[0, 1] = P[3]
    Pmat[1, 1] = P[4]
    Pmat[2, 1] = P[5]
    Pmat[0, 2] = P[6]
    Pmat[1, 2] = P[7]
    Pmat[2, 2] = P[8]

    FT = Fmat.transpose()
    #  print('Fmat','FT')
    #  print(Fmat,FT)
    I = np.eye(3)
    invF = np.linalg.inv(Fmat)
    E = (np.dot(FT, Fmat) - I) * 0.5
    S = np.dot(invF, Pmat)

    Evec = [E[0, 0], E[0, 1], E[0, 2], E[1, 0], E[1, 1], E[1, 2], E[2, 0], E[2, 1], E[2, 2]]
    Svec = [S[0, 0], S[0, 1], S[0, 2], S[1, 0], S[1, 1], S[1, 2], S[2, 0], S[2, 1], S[2, 2]]
    return np.concatenate([Evec, Svec])

for path in range(len(allFiles)):
	check_call(["python3 rve_solver.py {} {} > ./thread{}.out".format(allFiles[path], msh[path], thread)], shell=True)
	ipath = int(allFiles[path][len('strainPath'):-4])

	F_path = pd.read_csv(prefix + "strain.csv", sep=';')
	P_path = pd.read_csv(prefix + "stress.csv", sep=';')
	avg_P = pd.read_csv(prefix + "Average_P_XX.csv", sep=';', names=["Time", "avg_P"])
	
	N = len(F_path)
	namesAdd = ['VolumFrac', 'Radius', 'CellSize',
				'GL_XX', 'GL_XY', 'GL_XZ', 'GL_YX', 'GL_YY', 'GL_YZ', 'GL_ZX','GL_ZY', 'GL_ZZ',
				'S_XX', 'S_XY', 'S_XZ', 'S_YX', 'S_YY', 'S_YZ', 'S_ZX', 'S_ZY', 'S_ZZ', 'TSTEP']
	
	if len(avg_P) > 1:
	    VRS[path][0] = P_path.loc[1].values[1]/avg_P.loc[1].values[1]
	    
	newData = list()
    
	for step in range(N):
		F = F_path.loc[step].values[1:]
		P = P_path.loc[step].values[1:]
		T = np.array([P_path.loc[step].values[0]])
		ES = compute_ES(F, P)
		# print(ES)
		newData.append(np.concatenate([VRS[path], ES, T]))
	newdf = pd.DataFrame(newData, columns=namesAdd)
	fname = 'data_path' + str(ipath) + '.csv'
	newdf.to_csv(fname, sep=';', index=False)
	# finalDf = pd.concat([df, newdf],axis=1)
	# fname = './Path_Res/data_path'+str(ipath)+'.csv'
	# finalDf.to_csv(fname,sep=';',index = False)

	'''if len(prefix) > 0:
		os.system('rm ' + prefix + '*')
	else:
		os.system('rm *step* Average_* energy.csv')
    '''
